﻿using System;
using System.Diagnostics;
using System.IO.Ports;
using System.Windows.Forms;
using ETherCheckDataAcq;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        private readonly ETherRealtimeClass ether;
        private bool IsInit = false;
        public Form1()
        {
            this.InitializeComponent();

            this.ether = new ETherRealtimeClass(0, 0x70);
            this.IsInit = false;
            this.ether.RegisterDataCallback(NewRealtimeData);
            this.ether.RegisterFileCallback(NewFileData);
            this.ether.RegisterProgressCallback(ProgressBarValue);
        }
        public void NewRealtimeData(int X1, int Y1, int X2, int Y2, int Xmix_or_percent, int Ymix_or_percent, int Theta_or_status_X, int Radius_or_status_Y)
        {
            //int ian = X1;
            this.listBox1.Items.Add($"NewRealtimeData: X1 = {X1}");
        }
        public void NewFileData(string full_filename)
        {
            //A new file has been received by the DLL. The provided value is the full path of
            // where this file is.
            this.listBox1.Items.Add($"NewFileData = \"{full_filename}\"");
        }
        public void ProgressBarValue(double bar_percentage)
        {
            //Set the progress bar to the provided percentage, 0 to 100.
            this.listBox1.Items.Add($"ProgressBarValue = {bar_percentage} %");
        }

        private void BtnOpen_Click(object sender, EventArgs e)
        {
            int port = 32;
            // der Variable port einen gültigen Wert zuweisen
            Debugger.Break();
            bool result = this.ether.OpenSerialConnection(port);
            if (result)
            {
                this.IsInit = true;
                this.listBox1.Items.Add("OpenSerialConnection erfolgreich");
            }
            else
            {
                this.listBox1.Items.Add("OpenSerialConnection fehlgeschlagen");
            }
        }

        private void BtnClose_Click(object sender, EventArgs e)
        {
            this.ether.CloseSerialConnection();
            this.IsInit = false;
        }

        private void BtnListPorts_Click(object sender, EventArgs e)
        {
            this.listBox1.Items.Add("Serial Ports:");
            this.listBox1.Items.AddRange(SerialPort.GetPortNames());
        }
    }
}